package cpcns.danganzhengli.guanlian.controller;

package .tmp;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganmenlei.model.GDangAnMenLei;
import cpcns.danganmenlei.service.IGDangAnMenLeiService;
import cpcns.danganzhengli.guanlian.service.IGuanLianService;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
@RequestMapping({"/guanLian"})
public class GuanLianController extends commonController {
  @Autowired
  private IGuanLianService guanLianService;
  
  @Autowired
  private ICommonService commonService;
  
  @Autowired
  private IGDangAnMenLeiService gDangAnMenLeiService;
  
  @RequestMapping({"/getAll.do"})
  public String getAll(HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
    try {
      Enumeration<?> rnames = getRequest().getParameterNames();
      JSONObject jsonObject = new JSONObject();
      for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
        String thisName = er.nextElement().toString();
        String thisValue = getRequest().getParameter(thisName);
        jsonObject.put(thisName, thisValue);
      } 
      String ml = request.getParameter("menLei");
      String zhuMenLei = getRequest().getParameter("zhuMenLei");
      StringBuffer sqlWhere = new StringBuffer();
      User user = getCurrentUser();
      Map<String, String> tjmap = new HashMap<>();
      String quanZongHao = request.getParameter("quanZongHao");
      tjmap.put("quanZongHao", quanZongHao);
      Iterator<String> iterator = jsonObject.keys();
      StringBuffer sqlSearch = new StringBuffer();
      sqlSearch.append("  t where  zhuangtai not in (3,4) ");
      sqlWhere.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
      boolean isqx = true;
      while (iterator.hasNext()) {
        String key = iterator.next();
        String value = jsonObject.getString(key);
        if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !key.equals("quanZongHao")) {
          if (key.contains("begin")) {
            key = key.substring(0, key.indexOf("begin"));
            sqlWhere.append(" and ").append(
                String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (key.contains("end")) {
            key = key.substring(0, key.indexOf("end"));
            sqlWhere.append(" and ").append(
                String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (!"server".equals(key) && !"table".equals(key) && !"orderBy".equals(key) && !"order".equals(key) && !"sort".equals(key) && !"zhuMenLei".equals(key)) {
            if ("hangBiaoShi".equals(key)) {
              if (StringUtils.isNotBlank(value))
                sqlWhere.append(" and hangBiaoShi not in ( select gl.GuanLianWenJianBiaoShi from ").append(CommStatic.getMenLeiToBiaoMing(zhuMenLei)).append("GuanLian gl where gl.GuanLianBiaoShi='").append(value)
                  .append("' and gl.guanlianleixing='").append(ml).append("') and hangBiaoShi !=").append(value); 
              continue;
            } 
            if (key.equals("zhuangTai")) {
              String str = value.replaceAll(",", "','");
              sqlWhere.append(" and zhuangTai in ('").append(str).append("')");
              continue;
            } 
            if (key.lastIndexOf("like") > 0) {
              key = key.substring(0, key.indexOf("like"));
              if (StringUtils.isNotBlank(value))
                sqlWhere.append(" and ").append(key).append(" like ").append("'%").append(value).append("%'"); 
              continue;
            } 
            if (StringUtils.isNotBlank(value) && !value.equals("null"))
              sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'"); 
          } 
        } 
      } 
      if (sqlWhere.length() > 0)
        sqlSearch.append(sqlWhere.toString()); 
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      model.addAttribute("page", page);
      model.addAttribute("rows", rows);
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      int start = (intPage - 1) * number;
      String tab = this.commonService.getFenLeiHaoToTable(ml);
      StringBuffer sql = new StringBuffer("select hangBiaoShi,biaoTi,dangHao,baoGuanQiXian,guiDangNianDu,menLei from ");
      PagerVO pagevo = this.guanLianService.getAllNews(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "hangBiaoShi"), tab);
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
      jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi")
        .replaceAll("BIAOTI", "biaoTi").replaceAll("DANGHAO", "dangHao").replaceAll("MENLEI", "menLei")
        .replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng")
        .replaceAll("GUIDANGBUMENBIAOSHI", "guiDangBuMenBiaoShi").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian")
        .replaceAll("GUIDANGNIANDU", "guiDangNianDu");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/guanLianWenJian.do"})
  public String guanLianWenJian(HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
    try {
      Enumeration<?> rnames = getRequest().getParameterNames();
      JSONObject jsonObject = new JSONObject();
      for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
        String thisName = er.nextElement().toString();
        String thisValue = getRequest().getParameter(thisName);
        jsonObject.put(thisName, thisValue);
      } 
      Iterator<String> iterator = jsonObject.keys();
      String menLei = getRequest().getParameter("menLei");
      StringBuilder sqlWhere = new StringBuilder(" where 1=1 ");
      String table = getRequest().getParameter("table");
      while (iterator.hasNext()) {
        String key = iterator.next();
        String value = jsonObject.getString(key);
        if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows")) {
          if (key.contains("begin")) {
            key = key.substring(0, key.indexOf("begin"));
            sqlWhere.append(" and ").append(
                String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (key.contains("end")) {
            key = key.substring(0, key.indexOf("end"));
            sqlWhere.append(" and ").append(
                String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (!"server".equals(key) && !"table".equals(key) && !"orderBy".equals(key) && !"order".equals(key) && !"sort".equals(key) && !"menLei".equals(key) && !"zhuMenLei".equals(key) && !"cxzt".equals(key)) {
            if ("hangBiaoShi".equals(key)) {
              if (StringUtils.isNotBlank(value))
                sqlWhere.append(" and hangBiaoShi in (select hangBiaoShi from ")
                  .append(table)
                  .append("GuanLian where guanLianBiaoShi = ")
                  .append(value).append(" and guanlianleixing='").append(menLei).append("') and hangBiaoShi !=").append(value); 
              continue;
            } 
            if (key.lastIndexOf("like") > 0) {
              key = key.substring(0, key.indexOf("like"));
              if (StringUtils.isNotBlank(value))
                sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value + "%'"); 
              continue;
            } 
            if (StringUtils.isNotBlank(value))
              sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'"); 
          } 
        } 
      } 
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      model.addAttribute("page", page);
      model.addAttribute("rows", rows);
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      int start = (intPage - 1) * number;
      table = CommStatic.getMenLeiToBiaoMing(menLei);
      table = String.valueOf(table) + "guanLian";
      StringBuffer sql = new StringBuffer("select hangBiaoShi,biaoTi,dangHao,baoGuanQiXian,guiDangNianDu,guanLianLeiXing as menLei from ");
      PagerVO pagevo = this.guanLianService.getAllNew(start, number, sql.toString(), sqlWhere.toString(), CommStatic.getOrderBy(request, "hangBiaoShi"), table);
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo).replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("BIAOTI", "biaoTi")
        .replaceAll("DANGHAO", "dangHao").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("GUIDANGNIANDU", "guiDangNianDu")
        .replaceAll("MENLEI", "menLei").replaceAll("GUANLIANLEIXING", "guanLianLeiXing");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/guanLian.do"})
  public String guanLian(HttpServletRequest request, HttpServletResponse response, Model model) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String cxzt = request.getParameter("cxzt");
    String menLei = request.getParameter("menLei");
    String table = request.getParameter("table");
    GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(menLei);
    if (dam != null)
      model.addAttribute("menLeiMingCheng", dam.getMingCheng()); 
    String mlstr = this.commonService.getMenLeiStr();
    model.addAttribute("hangBiaoShi", hangBiaoShi);
    model.addAttribute("cxzt", cxzt);
    model.addAttribute("menLei", menLei);
    model.addAttribute("mlstr", mlstr);
    model.addAttribute("table", table);
    return "danganzhengli/guanLian/guanLianList";
  }
  
  @RequestMapping({"/toAddWenJian.do"})
  public String toAddWenJian(Model model) {
    String guanLianBiaoShi = getRequest().getParameter("guanLianBiaoShi");
    String cxzt = getRequest().getParameter("cxzt");
    String zhuMenLei = getRequest().getParameter("zhuMenLei");
    String menLei = getRequest().getParameter("menLei");
    GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(menLei);
    if (dam != null)
      model.addAttribute("menLeiMingCheng", dam.getMingCheng()); 
    String mlstr = this.commonService.getMenLeiStr();
    model.addAttribute("mlstr", mlstr);
    model.addAttribute("guanLianBiaoShi", guanLianBiaoShi);
    model.addAttribute("cxzt", cxzt);
    model.addAttribute("menLei", menLei);
    model.addAttribute("zhuMenLei", zhuMenLei);
    return "danganzhengli/guanLian/addWenJian";
  }
  
  @RequestMapping({"/addGuanLianWenJian.do"})
  public String addGuanLianWenJian(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShis = request.getParameter("hangBiaoShi");
    String guanLianBiaoShi = request.getParameter("guanLianBiaoShi");
    String server = request.getParameter("server");
    String menLei = request.getParameter("menLei");
    String zhuMenLei = getRequest().getParameter("zhuMenLei");
    ResultMessage rm = new ResultMessage();
    String info = "";
    try {
      String[] bglhangBiaoShi = hangBiaoShis.split(",");
      JSONObject jsonObject = new JSONObject();
      for (int i = 0; i < bglhangBiaoShi.length; i++) {
        String tb = String.valueOf(CommStatic.getMenLeiToBiaoMing(zhuMenLei)) + "GuanLian";
        String guanLianTable = this.commonService.getFenLeiHaoToTable(menLei);
        StringBuilder sql = (new StringBuilder("select hangBiaoShi,biaoTi,dangHao,baoGuanQiXian,guiDangNianDu from "))
          .append(guanLianTable).append(" where hangBiaoShi=").append(bglhangBiaoShi[i]);
        List<Object[]> list = this.guanLianService.getList(sql.toString());
        if (list != null && list.size() > 0) {
          int hbs = this.guanLianService.getPk(tb);
          Object[] obj = list.get(0);
          StringBuilder instsql = (new StringBuilder(" INSERT INTO ")).append(tb).append("(")
            .append("HANGBIAOSHI,").append("GUANLIANBIAOSHI,").append("BIAOTI,").append("DANGHAO,").append("BAOGUANQIXIAN,")
            .append("GUIDANGNIANDU,").append("guanLianWenJianBiaoShi,")
            .append("GUANLIANLEIXING,").append("BANBENHAO,").append("BEIYONGZIFU,").append("BEIYONGZI,")
            .append("CIXU").append(")").append(" VALUES (")
            .append(hbs).append(",").append(guanLianBiaoShi).append(",'").append(obj[1]).append("','").append(obj[2]).append("','").append(obj[3]).append("',")
            .append(obj[4]).append(",").append(obj[0]).append(",'")
            .append(menLei).append("',null,null,null,null)");
          this.guanLianService.update(instsql.toString());
        } 
        rm.setSuccess(true);
        info = "关联成功！";
        rm.setInfo(info);
        responseWriter(response, rm.toString());
      } 
    } catch (Exception e) {
      e.printStackTrace();
      info = "关联失败！";
      rm.setSuccess(false);
    } 
    return null;
  }
  
  @RequestMapping({"/removeWenJian.do"})
  public void removeWenJian(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String hangBiaoShis = request.getParameter("hangBiaoShis");
    String hangBiaoS = request.getParameter("hangBiaoShi");
    String menLei = request.getParameter("menLei");
    String zhuMenLei = request.getParameter("zhuMenLei");
    if (hangBiaoShis.endsWith(","))
      hangBiaoShis = hangBiaoShis.substring(0, hangBiaoShis.length() - 1); 
    String tb = String.valueOf(CommStatic.getMenLeiToBiaoMing(zhuMenLei)) + "GuanLian";
    StringBuffer sql = (new StringBuffer()).append(" Delete FROM ").append(tb)
      .append(" where hangBiaoShi in(").append(hangBiaoShis).append(") and guanLianBiaoShi = ").append(hangBiaoS);
    String info = "";
    try {
      this.guanLianService.deleteGuanLianJian(sql.toString());
      info = "删除成功！";
    } catch (Exception e) {
      e.printStackTrace();
      rm.setSuccess(false);
      info = "删除失败！";
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
}
